Index: apps/app_stack.c
===================================================================
--- apps/app_stack.c	(revision 85635)
+++ apps/app_stack.c	(working copy)
@@ -121,7 +121,7 @@
 static int gosubif_exec(struct ast_channel *chan, void *data)
 {
 	struct ast_module_user *u;
-	char *condition="", *label1, *label2, *args;
+	char *condition="", *label1, *label2, *label, *args;
 	int res=0;
 
 	if (ast_strlen_zero(data)) {
@@ -133,18 +133,14 @@
 
 	u = ast_module_user_add(chan);
 
-	condition = strsep(&args, "?");
-	label1 = strsep(&args, ":");
-	label2 = args;
-
-	if (pbx_checkcondition(condition)) {
-		if (label1) {
-			res = gosub_exec(chan, label1);
-		}
-	} else if (label2) {
-		res = gosub_exec(chan, label2);
+	condition = strsep(&args,"?");
+	label1 = strsep(&args,":");
+	label2 = strsep(&args,"");
+	label = pbx_checkcondition(condition) ? label1 : label2;
+	if (ast_strlen_zero(label)) {
+		return 0;
 	}
-
+	res = gosub_exec(chan, label);
 	ast_module_user_remove(u);
 	return res;
 }
